<?php defined('SYSPATH') or die('No direct script access.');

class Model_Faculty extends Model
{
    private $id;

    public static function with($id) {
        $f = new self();
        $f->id = (int) $id;
        return $f;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `GetDisciplines`(:id, :semesterID)";
        $query = DB::query(Database::SELECT, $sql)
            ->param(':id', $this->id)
            ->param(':semesterID', $semesterID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true);

        return $list;
    }

    public function getGroups($grade) {
        $sql = "CALL `GetGroups`(:grade, :id)";
        return DB::query(Database::SELECT, $sql)
            ->param(':grade', (int) $grade)
            ->param(':id', $this->id)
            ->execute()->as_array();
    }

    public function getSubjects() {
        $sql = "CALL `GetSubjects`(:faculty)";
        return DB::query(Database::SELECT, $sql)
            ->param(':faculty', $this->id)
            ->execute()->as_array();
    }
}
