<?php defined('SYSPATH') or die('No direct script access.');

class Model_Grades extends Model
{
    public static function getGrades() {
        $sql = "CALL `GetGrades`();";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function toArray() {
        $grades = self::GetGrades();
        $list = array();

        foreach ($grades as $row) {
            if ($row['Degree'] == 'bachelor' || $row['Degree'] == 'specialist')
                $row['Title'] = 'Курс ' . $row['Num'];
            if ($row['Degree'] == 'master')
                $row['Title'] = 'Магистратура ' . $row['Num'];
            $list[] = $row;
        }

        return $list;
    }

    public static function getDegreeTitle($degree) {
        return RusLang::tr($degree);
    }

    public static function getDegreeType($degree) {
        switch ($degree) {
            case 'Бакалавр':
                return 'bachelor';
            case 'Магистр':
                return 'master';
            case 'Специалист':
                return 'specialist';
            default:
                return $degree;
        }
    }

    /** @return array an array with elements, grouped by grades. */
    public static function toStructuredArray() {
        $grades = self::toArray();
        $list = array();
        $degree = 'null';
        $i = 0;

        foreach ($grades as $row) {
            if ($degree != $row['Degree']) {
                $degree = $row['Degree'];
                $i++;
            }

            $list[$i]['Title'] = self::getDegreeTitle($row['Degree']);
            $list[$i]['Grades'][] = $row;
        }

        return $list;
    }
}
