<?php

class Model_Helper_CourseWorkBuilder extends Model_Helper_Builder
{
    const COURSEWORK_DISCIPLINE_ID = 346;

    public function create() {
        $this->data += [
            'Lectures'  => 0,
            'Practice'  => 0,
            'Labs'      => 0,
            'IsLocked'  => false,
            'Type'      => 'grading_credit',
        ];

        if (count($this->data) < 11)  # fixme: bad const
            throw new InvalidArgumentException('not enough arguments');

        return new Model_CourseWork($this->data, false);
    }

    function & author($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('author id is incorrect');
        $this->data['AuthorID'] = (int) $id;
        return $this;
    }

    function & grade($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('grade id is incorrect');
        $this->data['GradeID'] = (int) $id;
        return $this;
    }

    function & faculty($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('faculty id is incorrect');
        $this->data['FacultyID'] = (int) $id;
        return $this;
    }

    /** Must be called after subtype() */
    function & subject($id) {
        if ($this->data['Subtype'] == Model_CourseWork::SCIENTIFIC)
            $id = self::COURSEWORK_DISCIPLINE_ID;

        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('subject id is incorrect');

        $this->data['SubjectID'] = (int) $id;
        return $this;
    }

    function & subtype($name) {
        switch ($name) {
            case Model_CourseWork::DISCIPLINARY:
            case Model_CourseWork::SCIENTIFIC:
                break;
            default:
                throw new InvalidArgumentException('Subtype is incorrect');
        }

        $this->data['Subtype'] = $name;
        return $this;
    }

    function & semester($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('semester id is incorrect');
        $this->data['SemesterID'] = (int) $id;
        return $this;
    }
}