<?php defined('SYSPATH') or die('No direct script access.');

class Model_Rating extends Model
{
    public static function GetStudentsForRating($disciplineID) {
        $sql = "CALL `GetStudentsForRating`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * Get the disciplines's roadmap (учебная карта).
     * @param $discipline int discipline id
     * @return Database_Result select from <tt>view_roadmap</tt> table
     */
    public static function getMapForDiscipline($discipline) {
        $sql = "CALL `GetRoadmap`('$discipline'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * @param $discipline int discipline id
     * @param $student int student id
     * @return Database_Result
     */
    public static function getRates($discipline, $student) {
        $sql = "CALL `GetRates`('$student', '$discipline'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * @param $discipline int discipline id
     * @param $student int student id
     * @return Database_Result
     */
    public static function getExamRates($discipline, $student) {
        $sql = "CALL `GetRatesExam`('$student', '$discipline'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function GetMapForDisciplineExam($disciplineID) {
        $sql = "CALL `GetRoadmapExam`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function getMapForStudent($studentID, $disciplineID)
    {
        $sql = "CALL `GetMapForStudent`('$studentID', '$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function getAttestationData($disciplineID, $groupID) {
        $sql = "CALL `GetAttestationData`($disciplineID, $groupID)";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function SetStudentRate($teacherID, $studentID, $submoduleID, $rate) {
        if ($rate == -1)
            unset($rate);
        $sql = "SELECT `SetStudentRate`(:teacherID, :studentID, :submoduleID, :rate) AS `Num`;";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':teacherID' => $teacherID,
                ':studentID' => $studentID,
                ':submoduleID' => $submoduleID,
                ':rate' => $rate
            ])->execute();
    }

    public static function getRatesForStudentsGroup($disciplineID, $groupID) {
        $sql = "CALL `GetRatesForGroup`(:disciplineID, :groupID)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':disciplineID' => $disciplineID,
                ':groupID' => $groupID,
            ])->execute();
    }

    public static function getRatesForStudentsGroupByStage($disciplineID, $groupID, $stage) {
        $sql = "CALL `GetRatesForGroupByStage`(:disciplineID, :groupID, :stage);";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':disciplineID' => $disciplineID,
                ':groupID' => $groupID,
                ':stage' => $stage
            ])->execute();
    }

    public static function getFinalFormInfo($disciplineID, $groupID) {
        $sql = "CALL `getFinalFormInfo`(:disciplineID, :groupID);";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':disciplineID' => $disciplineID,
                ':groupID' => $groupID,
            ])->execute();
    }

    /**
     * Get count of related with discipline records in `rating_table`.
     * @param Model_Discipline $discipline
     * @return int
     */
    public static function count(Model_Discipline &$discipline)
    {
        $sql = "SELECT `Discipline_CountRatings`(:id) AS `res`;";
        $count = DB::query(Database::SELECT, $sql)
            ->param(':id', $discipline->ID)
            ->execute()
            ->get('res');

        return (int)$count;
    }

    public static function setExamPeriodOption($studentID, $submoduleID, $option) {
        // option is absence or pass or null
        $sql = "SELECT `SetExamPeriodOption`(:studentID, :submoduleID, :option) As `ErrorCode`;";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':studentID' => $studentID,
                ':submoduleID' => $submoduleID,
                ':option' => $option
            ])->execute()[0];
    }
}
