<?php defined('SYSPATH') or die('No direct script access.');

/**
 * Class Model_Semesters
 *
 * @property int ID
 * @property int Num
 * @property int Year
 * @property string Season
 */
class Model_Semesters extends Model
{
    private $data;

    public function __construct($data) {
        $this->data = $data;
        $this->data['Season'] = $this->data['Num'] == 1 ? 'autumn' : 'spring';
    }

    public function __isset($name) {
        return isset($this->data[$name]);
    }

    public function __get($name) {
        return $this->data[$name];
    }


    public static function load($id) {
        $data = DB::query(Database::SELECT, "CALL `GetSemesterInfo`(:id)")
            ->param(':id', $id)->execute();

        if (!$data->count())
            throw new LogicException(Error::ID_IS_INCORRECT);

        return new self($data[0]);
    }

    public static function loadAll() {
        $res = DB::query(Database::SELECT, "CALL `GetSemesters`()")->execute();

        $list = [];
        foreach ($res as $semester)
            $list[$semester['ID']] = new self($semester);

        return $list;
    }
}