<?php defined('SYSPATH') or die('No direct script access.');

class Model_Students extends Model
{
    public static function ofDiscipline($id) {
        $sql = "CALL `GetStudentsForDiscipline`('$id'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * @param $group int group id
     * @return Database_Result
     */
    public static function ofGroup($group, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;;
        $sql = "CALL `GetStudents`('$group', $semesterID); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function getGradeID($gradeNum, $degree) {
        $degree = Database::instance()->escape($degree);
        $sql = "SELECT `GetGradeID`('$gradeNum', $degree) AS `ID`; ";
        return DB::query(Database::SELECT, $sql)->execute()->get('ID');
    }

    public static function byStudyGroup($groupID) {
        return self::collect(self::ofGroup($groupID));
    }

    public static function byFaculty($facultyID, $gradeID = null, $groupID = null, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `GetStudentsByFaculty`(:faculty, :grade, :group, :semester); ";
        $students = DB::query(Database::SELECT, $sql)
            ->parameters([
                ':faculty' => (int) $facultyID,
                ':grade' => (int) $gradeID,
                ':group' => (int) $groupID,
                ':semester' => (int) $semesterID,
            ])
            ->execute();
        return self::collect($students);
    }

    public static function searchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID) {
        $Name = Database::instance()->escape($Name);
        $sql = "CALL `SearchStudents`('$GradeID', '$GroupID', '$FacultyID', $Name, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function searchStudentsByName($name, $facultyID = null, $gradeID = null, $groupID = null, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `SearchStudentsByName`(:name, :faculty, :grade, :group, :semester)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':name' => $name,
                ':faculty' => (int) $facultyID,
                ':grade' => (int) $gradeID,
                ':group' => (int) $groupID,
                ':semester' => (int) $semesterID,
            ])->execute()->as_array();
    }

    private static function collect($students) {
        $studentsHandled = array();
        foreach($students as $row) {
            $row['Degree'] = Model_Grades::getDegreeTitle($row['Degree']);
            $studentsHandled[] = $row;
        }
        return $studentsHandled;
    }

    public static function NotAttendingDiscipline($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID) {
        $students = self::searchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID);
        return self::collect($students);
    }

    /*
     * TODO:
     *      a wrapper around `view_students` table
     *      see GetStudents, SearchStudents procedures.
     */
}