<?php defined('SYSPATH') or die('No direct script access.');
  
class Model_Teacher extends Model
{
    public $ID;

    public static function with($id) {
        //fixme: teacher may not exist
        if (!is_numeric($id) || $id <= 0)
            throw new LogicException(Error::ID_IS_INCORRECT);

        $t = new self();
        $t->ID = (int) $id;
        return $t;
    }


    public function changeInfo($lastName, $firstName, $secondName, $degreeID, $departmentID) {
        $sql = "SELECT `ChangeTeacherInfo`(:id, :last, :first, :second, :degree, :department) AS `Num`;";
        $res = DB::query(Database::SELECT, $sql)
            ->parameters([
                ':id' => $this->ID,
                ':last' => $lastName,
                ':first' => $firstName,
                ':second' => $secondName,
                ':degree' => $degreeID,
                ':department' => $departmentID,
            ])->execute()->get('Num');
        return ( $res == 0 );
    }

    /** @return Model_Discipline[] */
    public function getDisciplines() {
        $semesterID = User::instance()->SemesterID;
        $sql = "CALL `GetDisciplinesForTeacher`(:id, :semesterID); ";
        $query = DB::query(Database::SELECT, $sql)
            ->param(':semesterID', $semesterID)
            ->param(':id', $this->ID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true);

        return $list;
    }

    /**
     * Get edit rights for discipline.
     * @param $discipline Model_Discipline
     * @return int  1 if teacher is bound to discipline,
     *              0 if he is from a dean office,
     *              -1 otherwise.
     */
    public function getRightsForDiscipline(Model_Discipline $discipline) {
        $sql = "SELECT `GetEditRightsForTeacher`(:teacher, :discipline) AS `Num`";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline->ID)
            ->param(':teacher', $this->ID)
            ->execute()->get('Num');
    }
}
