<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function getFaculties() {
        $sql = "CALL `GetFaculties`(); ";
        return DB::query(Database::SELECT, $sql)->execute()->as_array();
    }

    public static function getJobPositions() {
        $sql = "CALL `GetJobPositions`(); ";
        return DB::query(Database::SELECT, $sql)->execute()->as_array();
    }

    public function getTeachersByFaculty($facultyID) {
        $sql = "CALL `GetTeachersByFaculty`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function byFaculty($facultyID) {
        $list = array();

        if ($facultyID > 0) {
            $teachers = self::getTeachersByFaculty($facultyID);

            foreach ($teachers as $row) {
                $row['DepartmentID'] = $row['DepID'];
                $row['DepartmentName'] = $row['DepName'];
                $list[] = $row;
            }
        }

        return $list;
    }

    public static function getTeachersByDepartment($departmentID) {
        $sql = "CALL `GetTeachersByDepartment`('$departmentID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function byDepartment($departmentID) {
        $teachers = self::getTeachersByDepartment($departmentID);
        $list = array();

        foreach ($teachers as $row) {
            $row['DepartmentName'] = $row['DepName'];
            $list[] = $row;
        }

        return $list;
    }

    public static function getNamesForDiscipline($disciplineID, $asConcat = false, $asAbbreviation = false) {
        $teachers = Model_Discipline::load($disciplineID)->getTeachers();
        $list = array();

        foreach ($teachers as $row) {
            if ($asAbbreviation) {
                $row['FirstName'] = UTF8::substr($row['FirstName'], 0, 1) . '.';
                if (!empty($row['SecondName']))
                    $row['SecondName'] = UTF8::substr($row['SecondName'], 0, 1) . '.';
            }

            if ($asConcat)
                $list[] = $row['LastName'] .' '. $row['FirstName'] .' '. $row['SecondName'];
            else
                $list[] = $row;
        }

        return $list;
    }

    public static function searchTeachers($FacultyID, $DepartmentID, $Last, $First, $Second) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', $Last, $First, $Second); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function searchTeacherNew($FacultyID, $DepartmentID, $Last, $First, $Second, $DisciplineID) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeacherNew`('$FacultyID', '$DepartmentID', $Last, $First, $Second, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
}